function [Af,Bf,Ainf,Binf,Ainf_cut,Binf_cut,D] = binary_encoding_creation( nx )

if nx == 1
    error('You can not encode one variable by fewer binaries!!!')
end   

% creation of ineq: A*del - B >= 0
% each row of ineq represents one encoded binary variable

% number of new auxiliary variables delta
    nd = ceil(log2(nx));    
        A = zeros(2^nd,nd);
        B = zeros(2^nd,1);  
    for i = 1:nd  
            j = (2^(i-1)); 
            a = [-1*ones(2^(nd-i),1); ones(2^(nd-i),1)];
            A(:,i) = repmat(a,j,1) ;
    end
    for i = 1:(2^nd)
        B(i) = nd - sum(A(i,:) == -1);
    end
%  feasible nodes
    Af = A(1:nx,:);
    Bf = B(1:nx,:);  
%     infeasible nodes for cutting => one node = one cut!
    Ainf = A(nx+1:end,:);
    Binf = B(nx+1:end,:);   
%     Binf = B(nx+1:end,:) -0.5;   
%     binary combination for nodes
    D = Af;
    D(D==-1) = 0;
    
%     -----------ENHANCED CUTS-----------------

% ALERT!! USE  log2  instead of log!!!?

% aproximately LOGARITMIC NUMBER OF CUTS: nu = ceil(log(size(Ainf,1)))
%  power of unalocated tuples or number of new cuts
 nu = size(Ainf,1);
 % matrix initialization for new optimized cuts   
% Ainf_cut = zeros(ceil(log(nu)),nd);
% Binf_cut = zeros(ceil(log(nu)),1);
 if nu>1   % if there is more than one infeasible node - than we can perform better cuts
         row = 0; % row inicialization
         i = 0;      
         while row ~= size(Ainf,1)
             i = i+1;
                 if nu == 3
                     ni = 1; % ceil(log(3))=2 but we need 1!!!
                 else
                     
                     % ALERT!! USE  log2  instead of log!!!?
%                       ni = ceil(log(nu)) -1 ; ?  - bad solution?
                     
                     ni = ceil(log(nu)); %  number of common binaries in step 
                 end
                 nj = 2^ni;  %  number of constraints to be replaced by one constraint in one step
                 row = row + nj;
                %  IF THERE WILL BE single cut for first unalocated node - we are
                %  connecting it with one of his neighbours
                 if nj == 1     
                   % finding of a common bits                     
                   nc_nodes = zeros(size(Ainf,1),1);
                   for j = 2:size(Ainf,1)
                     nc_nodes(j) = sum(Ainf(1,:) == Ainf(j,:));
                   end
                   %  difference only in one point = neighbour vertexes
                   neigh = find(nc_nodes == nd-1);
                   % complex cut - combining cut for last node with his neighbour
                   Ainf_cut(i,:) = Ainf(1,:).*[Ainf(neigh(1),:) == Ainf((1),:)];
                   Binf_cut(i) = sum(Ainf_cut(i,:) == 1);   
%                    Binf_cut{i} = sum(Ainf_cut{i} == 1);                        
                 else                                                      
                     Ainf_cut(i,:) = [Ainf(end+1-row,1:end-ni) zeros(1,ni)];
                     Binf_cut(i) = sum(Ainf_cut(i,:) == 1);   
                     %   Binf_cut{i} = size(Ainf_cut{i},2) - sum(Ainf_cut{i} == -1);   
                        % OLARU APPROACH
                        %  Binf_cut{i} = size(Ainf_cut{i},2) - sum(Ainf_cut{i} == -1) -0.5 ;   
                     nu = nu-nj;
                     if nu == 0
                         break
                     end                
                 end
         end
 elseif nu == 1
    Ainf_cut(1,:) = Ainf;
    Binf_cut(1) = Binf;
%      Ainf_cut{1} = Ainf;
%     Binf_cut{1} = Binf;
 elseif nu == 0
     Ainf_cut = [];
     Binf_cut = [];
 end
 
end




