function [yalmip_fsm_obj, yalmip_fsm_var ] = yalmip_fsm(states, trans , variables, N, Options)

ts = tic;

if nargin < 4
    error('Not enough input arguments!')
end
if nargin < 5
    Options = [];
end
if ~isfield(Options, 'verbose')
    Options.verbose = 0;
end
%     THIS IS UNUSED SO FAR!!!
if ~isfield(Options, 'integer_tol')
    Options.integer_tol = 1e-6;
end
if ~isfield(Options, 'encoding')
     Options.encoding = 'unary';
end
if ~isfield(Options, 'cuts')
     Options.encoding = 'enhanced';
end

%  ----------INTERNAL VARIABLES DECLARATION------------
if exist('variables','var')
    for i = 1:length(variables.names)
        if isequal(variables.ind{i},'r')
            eval([variables.names{i} '= sdpvar(repmat(variables.sizes{i}(1),1,N+1),repmat(variables.sizes{i}(2),1,N+1),''full'');' ]);
        elseif isequal(variables.ind{i},'b')
            eval([variables.names{i} '= binvar(repmat(variables.sizes{i}(1),1,N),repmat(variables.sizes{i}(2),1,N),''full'');' ]);
        end
        %  ---------- VARIABLES FOR OUTPUT ------------------
        yalmip_fsm_var.(variables.names{i}) = eval([variables.names{i}]);
    end
else
    error('variables are in bad form or empty!')
end

F = []; % inicialization of Yalmip constraints

% -----------PARAMETERS--------------
if ~isempty(variables.param.val)
    for i = 1:length(variables.param.val)
        eval([variables.param.val{i} ';'])
    end
end
% this loop dont have to be used -> change in variables declaration needed,
% instead of {k} time step, put {:} for all time steps?
for k = 1:(N+1)
    if ~isempty(variables.param.ineq)
        for i = 1:length(variables.param.ineq)
            eval(['F = [F,' variables.param.ineq{i} '];'])
        end
    end
    if ~isempty(variables.param.eq)
        for i = 1:length(variables.param.eq)
            eval(['F = [F,' variables.param.eq{i} '];'])
        end
    end
end

nx = length(states); % number of states
nt = length(trans); % number of transitions
% ---------------BINARY ENCODING - MIP inequalities---------------
 if isequal(Options.encoding,'binary')    
    if nx > 1
        nd = ceil(log2(nx)); % number of new auxiliary var d for states encoding
    else
        error('You want to binary encode a single variable!') 
    end        
    [A,B,Ainf,Binf,Ainf_cut,Binf_cut,D] = binary_encoding_creation( nx );
    % D - feasible nodes combination for states 
    % A,B - inequalities for feasible nodes
    % Ainf, Binf - ineq for infeasible nodes  
    % Ainf_cut, Binf_cut - optimized cuts for infeasible nodes  
 end
% -----------INDEXES FOR connecting states with transitions-------------
s_index = nan(nx, 1);
ts_index = nan(nt, 2);
for i = 1:nx
    s_index(i) =  states(i).state_index;
end
for i = 1:nt
    ts_index(i,1) = trans(i).state_one.state_index;
    ts_index(i,2) = trans(i).state_two.state_index;
end
% --------POSSIBLE TRANSITIONS MATRIX----------------------------  
poss_trans = zeros(nt,2); 
for i = 1:nt
    poss_trans(i,1) = find(s_index == ts_index(i,1));
    poss_trans(i,2) = find(s_index == ts_index(i,2));
end
% ----------AUXILIARY VARIABLES-----------
 if isequal(Options.encoding,'unary')    
    % ------------UNARY ENCODING VARIABLES-----------
    %  states
    in_state = binvar(repmat(nx,1,N+1),repmat(1,1,N+1),'full');
    %  transitions
    t = binvar(repmat(nt,1,N),repmat(1,1,N),'full');
    % matrix of transitions, for actualization of states
    T = repmat({double2sdpvar(zeros(nx))},1,N);
 elseif isequal(Options.encoding,'binary')    
    % -------------BINARY ENCODING VARIABLES--------------
    % auxiliary var for states encoding
    d = binvar(repmat(nd,1,N+1),repmat(1,1,N+1),'full');   
    % transitions
    t = binvar(repmat(nt,1,N),repmat(1,1,N),'full');
    % matrix of transitions, for actualization of states
    T = repmat({double2sdpvar(zeros(nd,1))},1,N);
 end

% ------------MODELING-------------------------------  
for k = 1:N    % N = prediction horizon    
 % --------------TRANSITIONS MATRIX-------------
 if isequal(Options.encoding,'unary')    
     % ------------UNARY ENCODING TRANSITIONS MATRIX-----------
    for i = 1:nt
        if poss_trans(i,1) == poss_trans(i,2)
            T{k}(poss_trans(i,1),poss_trans(i,2)) = 1-t{k}(i) - sum(t{k}(setdiff(1:nt,i)));
        else
            T{k}(poss_trans(i,1),poss_trans(i,2)) =  T{k}(poss_trans(i,1),poss_trans(i,2)) - t{k}(i);
            T{k}(poss_trans(i,2),poss_trans(i,1)) =  T{k}(poss_trans(i,2),poss_trans(i,1)) + t{k}(i);
        end
    end    
 elseif isequal(Options.encoding,'binary')    
     % ------------BINARY ENCODING TRANSITIONS MATRIX-----------
     from = poss_trans(:,1);
     to = poss_trans(:,2);
     T{k} = ((D(to,:) - D(from,:))')*t{k};     
 end
 
    % ------------------TRANSITIONS MODELING------------
    for i = 1:nt                   
        
        % %  check if conditions are true!!! for multiple trans from one state
        %  use matrix "from" or "poss_trans" to chceck more than one trans from one state
        %  eval([ 'double(' trans(i).conditions ')'])
        
        %   OR relation  - not working!!!!
        if length(trans(i).conditions) > 1
            % NEW AUX VARIABLE tdelta - for OR relation
            tdelta{i} = binvar(repmat(length(trans(i).conditions),1,N),repmat(1,1,N),'full');           
            for j = 1:length(trans(i).conditions)
                model{j} = eval([trans(i).conditions{j}]);     
                F = [F, implies( model{j} , tdelta{i}{k}(j) )];
                F = [F, implies( tdelta{i}{k}(j), model{j} )];          
            end
            clear model;
            model = or( tdelta{i}{k}(:) );           
        %  AND relation
        else             
            model = eval([trans(i).conditions{1}]);                 
        end        
        %  logical equivalence:  trans <-> switching condition (model)
        if isequal(Options.encoding,'unary')
            F = [F, implies( [model, in_state{k}(poss_trans(i,1)) == 1] , t{k}(i) )];
            F = [F, implies( t{k}(i), [model, in_state{k}(poss_trans(i,1)) == 1]  )];
        elseif isequal(Options.encoding,'binary')
            F = [F, implies( [model, A(poss_trans(i,1),:)*d{k} >= (B(poss_trans(i,1)) -0.5) ] , t{k}(i) )];
            F = [F, implies( t{k}(i), [model, A(poss_trans(i,1),:)*d{k} >= (B(poss_trans(i,1))) ]  )];
        end              
        clear model;
    end
    
    % ------------------STATES MODELING------------
    for i = 1:nx
        for j = 1:length(states(i).state_constr)
            model = eval([states(i).state_constr{j}]);
            %  imply:  state -> state constraints or dynamics (model)
            if isequal(Options.encoding,'unary')    
                 F = [F, implies(in_state{k}(i), model)];      
            elseif isequal(Options.encoding,'binary')  
                 F = [F, implies( A(i,:)*d{k}-B(i) >= -0.5, model)];             
            end
        end
        clear model;
    end
    % -----ACTUALIZATION OF STATES + transition and state constraints------
    if isequal(Options.encoding,'unary')    
         F = [F, in_state{k+1} == in_state{k} + sum(T{k},2)];
         F = [F, sum(in_state{k}) == 1 ];
    elseif isequal(Options.encoding,'binary') 
         F = [F, d{k+1} == d{k} + T{k}];       
         %------------ separation of infeasible nodes -----------------
         if isequal(Options.cuts,'basic')   
            %    basic approach - one node one cut - deep
            if ~isempty(Ainf)
                F = [F, Ainf*d{k} <= Binf-1 ];
            end
         elseif isequal(Options.cuts,'enhanced')  
            %   enhanced deep cuts
            if ~isempty(Ainf_cut)
                F = [F, Ainf_cut*d{k} <= Binf_cut-1 ];
            end
         end
    end    
    F = [F, sum(t{k}) <= 1 ]; 
    
end
% elapsed time
    if  Options.verbose ~= 0
        fprintf('Modeling ');
        toc(ts)
    end
% ------------OUTPUT OF FUNCTION--------------------------
    yalmip_fsm_obj = F;
    yalmip_fsm_var.t = t;
    if isequal(Options.encoding,'unary')  
        yalmip_fsm_var.in_state = in_state;
    elseif isequal(Options.encoding,'binary') 
        yalmip_fsm_var.d = d;
    end
    
end


